unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    TrackBar1: TTrackBar;
    ColorBox1: TColorBox;
    Button1: TButton;
    Button2: TButton;
    Image2: TImage;
    Timer1: TTimer;
    TrackBar2: TTrackBar;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
    const
 AC_SRC_ALPHA = $1;
var                            
  Form1: TForm1;
  down:boolean=false;
  colors:Tcolor;
  PenTochka:array of array of boolean;
  xold,Yold:integer;
  cldefaut:Tcolor;
implementation

{$R *.dfm}
{Procedure SetColorDraw_e(x1,y1:integer;color:Tcolor);
  var x,y:integer;
      cl2,cl:Tcolor;
      R,G,B:byte;
      rmC,rm,m,R2,G2,B2:integer;
      alpha:real;
begin
    cl:=CLWhite;
    r:=GetRValue(cl);
    g:=GetgValue(cl);
    B:=GetBValue(cl);
    alpha:=form1.TrackBar1.Position/10;
    r2:=Round((GetRValue(color)*alpha+(1-alpha)*r));
    g2:=Round((GetgValue(color)*alpha+(1-alpha)*g));
    B2:=Round((GetBValue(color)*alpha+(1-alpha)*b));
    cldefaut:=RGB(r2,g2,b2);
{
if alpha=100 then
//  for m:=0 to PenTochkaCount-1 do begin
//  x:=x1+PenTochka[m].X;
//  y:=y1+PenTochka[m].y;
  form1.image1.Canvas.Pixels[x,y]:=color
  end
  else
  for m:=0 to PenTochkaCount-1 do begin
//  x:=x1+PenTochka[m].X;
//  y:=y1+PenTochka[m].y;
  cl:=form1.image1.Canvas.Pixels[x,y];
  if cl<>cldefaut then begin
  r:=Byte(cl);
  g:= Byte(cl shr 8);
  B:=Byte(cl shr 16);
    r2:=Round((Byte(color)*alpha+(1-alpha)*r));
    g2:=Round((Byte(color shr 8)*alpha+(1-alpha)*g));
    B2:=Round((Byte(color shr 16)*alpha+(1-alpha)*b));
    cl2:=RGB(r2,g2,b2);
    form1.image1.Canvas.Pixels[x,y]:=cl2
    end;
  end;

//  sleep(20);
{.Blue=alpha* .Blue+(1-alpha)* .Blue
.Green=alpha* .Green+(1-alpha)* .Green
.Red=alpha* .Red+(1-alpha)* .Red
.alpha=alpha* .alpha+(1-alpha)* .alpha
 }

{end;}
Procedure SetColorDraw(x1,y1:integer;color:Tcolor);
type
pRGBTriple = ^TRGBTriple;
TRGBTriple =
PACKED RECORD
  rgbtBlue : BYTE;
  rgbtGreen: BYTE;
  rgbtRed  : BYTE;
END;
TYPE   TRGBTripleArray = ARRAY[WORD] OF TRGBTriple;
pRGBTripleArray = ^TRGBTripleArray;
var
Row:
    pRGBTripleArray;
   r,g,b:byte;
   alpha:real;
   r2,g2,b2:byte;
   r2i,g2i,b2i:byte;
   cl:integer;
   m:integer;
   x,y:integer;

begin
    cl:=CLWhite;
    r:=GetRValue(cl);
    g:=GetgValue(cl);
    B:=GetBValue(cl);
    alpha:=form1.TrackBar1.Position/10;

    r2i:=Round((GetRValue(color)*alpha+(1-alpha)*r));
    g2i:=Round((GetgValue(color)*alpha+(1-alpha)*g));
    B2i:=Round((GetBValue(color)*alpha+(1-alpha)*b));

  alpha:=form1.TrackBar1.Position/10;

  for y:=y1 to y1+form1.Image2.Width-1 do begin
  if y>(form1.Image1.Picture.Bitmap.Height-1) then exit;
  if y<0 then break;
      row:=form1.Image1.Picture.Bitmap.ScanLine[y];

  for x:=x1 to x1+form1.Image2.Width-1 do begin
  if PenTochka[x-x1,y-y1] then begin
  if x<0 then break;
  if x>(form1.Image1.Picture.Bitmap.Width-1) then break;
    r:=Row[x].rgbtRed;
    g:=Row[x].rgbtGreen;
    b:=Row[x].rgbtBlue;
    if (rgb(r,g,b)<>rgb(r2i,g2i,b2i)) then begin
    r2:=Round((Byte(color)*alpha+(1-alpha)*r));
    g2:=Round((Byte(color shr 8)*alpha+(1-alpha)*g));
    B2:=Round((Byte(color shr 16)*alpha+(1-alpha)*b));
    Row[x].rgbtRed:=r2;
    Row[x].rgbtGreen:=g2;
    Row[x].rgbtBlue:=b2;
    end;
  end;end;
  end;
    form1.image1.Canvas.Draw(0,0,form1.Image1.Picture.Bitmap);

end;



procedure TForm1.FormCreate(Sender: TObject);
begin
form1.Image1.Picture.Bitmap:=TBitmap.Create;
form1.Image1.Picture.Bitmap.Height:=form1.Image1.Height;
form1.Image1.Picture.Bitmap.Width:=form1.Image1.Width;
form1.Image1.Picture.Bitmap.PixelFormat:=pf24bit;

form1.Button1Click(nil);
form1.Button2Click(nil);

end;

procedure TForm1.ColorBox1Change(Sender: TObject);
begin
colors:=form1.ColorBox1.Selected;

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  down:=true;
  xold:=x;
  yold:=y;

end;



procedure DrawLine(x1,y1, x2,y2: Integer);
var b,dx,dy,y,x,i:integer;
begin
  dx:=abs(x2-x1);
  dy:=abs(y2-y1);

  if dx >= dy then
  begin
    if (x1<x2) then begin
    i:=x1;
      while i<x2 do
      begin
      i:=i+3;
        y:=Round(((y2-y1)/(x2-x1))*i + (y1-x1*((y2-y1)/(x2-x1))));
//        SetPix(i,y);
        SetColorDraw(i,y,colors);
      end; end;

    if (x2<x1) then begin
    i:=x2;
    while i<x1 do
      begin
      i:=i+3;
        y:=Round(((y2-y1)/(x2-x1))*i + (y1-x1*((y2-y1)/(x2-x1))));
        SetColorDraw(i,y,colors);
      end;end;
  end;

  if dx<dy then
  begin
    if (y1<y2) then begin
    i:=y1;
      while i<y2 do
      begin
      i:=i+3;
        x:=Round(((x2-x1)/(y2-y1))*i + (x1-y1*((x2-x1)/(y2-y1))));
        SetColorDraw(x,i,colors);
      end;end;

    if (y2<y1) then begin
    i:=y2;
    while i<y1 do
      begin
      i:=i+3;
        x:=Round(((x2-x1)/(y2-y1))*i + (x1-y1*((x2-x1)/(y2-y1))));
       SetColorDraw(x,i,colors);
      end;
      end;
  end;
  end;
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
  lx,ly,dx,dy,i:integer;
  dlina:integer;
begin
if down then  begin
   dx:=x-xold;
   dy:=y-yold;
   DrawLine(xold,yold,x,y);
   xold:=x;
   yold:=y;
end;

end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  down:=false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
form1.Image1.Canvas.Pen.Color:=clwhite;
form1.Image1.Canvas.Brush.Color:=clwhite;
form1.Image1.Canvas.Rectangle(form1.Image1.Canvas.ClipRect);
end;
Function max(a,b:integer):integer;
begin
 if a>b then result:=a
 else result:=b;
end;
procedure TForm1.Button2Click(Sender: TObject);
var x,y:integer;
    t,w,h:integer;
begin
colors:=form1.ColorBox1.Selected;


form1.Image2.Canvas.Brush.Color:=clwhite;
form1.Image2.Canvas.Rectangle(form1.Image2.Canvas.ClipRect);

form1.Image2.Canvas.pen.Color:=colors;
form1.Image2.Canvas.Brush.Color:=colors;
form1.Image2.Canvas.Ellipse(2,2,form1.TrackBar2.Position*5,form1.TrackBar2.Position*5);
  w:=image2.Width-4;
  h:=image2.Height-4;

//  PenTochkaCount:=w;
  setlength(PenTochka,max(form1.Image2.Width,form1.Image2.Height),max(form1.Image2.Width,form1.Image2.Height));
t:=0;
  for y:=1 to h do
  for x:=1 to w do
      PenTochka[x,y]:=image2.Canvas.Pixels[x,y]<>clwhite;
//    PenTochka[t].X:=x;
//    PenTochka[t].y:=y;



//form1.Image2.Canvas.pen.Color:=colors;
//form1.Image2.Canvas.Brush.color:=colors;



end;


procedure TForm1.Timer1Timer(Sender: TObject);
begin
form1.Image1.Canvas.Pen.Color:=clwhite;
form1.Image1.Canvas.Brush.Color:=clwhite;
form1.Image1.Canvas.Rectangle(form1.Image1.Canvas.ClipRect);

form1.Timer1.Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var x,y:integer;
    t,w,h:integer;
    cl:Tcolor;
    r,g,b:byte;
    r2,g2,b2:byte;
    alpha:integer;
    rx,ry,x1,y1,cx,cy:integer;
begin
colors:=form1.ColorBox1.Selected;


form1.Image2.Canvas.Brush.Color:=clwhite;
form1.Image2.Canvas.Rectangle(form1.Image2.Canvas.ClipRect);

form1.Image2.Canvas.pen.Color:=colors;
form1.Image2.Canvas.Brush.Color:=colors;
rx:=10;
rY:=10;
cx:=form1.Image2.Width;
cy:=form1.Image2.Height;
for X:=0 to 360 do begin
  form1.Image2.Canvas.Pixels[random(cx),random(cy)]:=CLBlack;

end;
  w:=image2.Width-4;
  h:=image2.Height-4;

//  PenTochkaCount:=w*h;
  setlength(PenTochka,max(form1.Image2.Width,form1.Image2.Height),max(form1.Image2.Width,form1.Image2.Height));
t:=0;
  for y:=1 to h do
  for x:=1 to w do
    PenTochka[x,y]:=image2.Canvas.Pixels[x,y]<>clwhite;

    



//form1.Image2.Canvas.pen.Color:=colors;
//form1.Image2.Canvas.Brush.color:=colors;



end;

end.
